jsFF._3DButtons =  Class.create();
Object.extend(jsFF._3DButtons, {
	buttons: new Array(),
	make3dButtons : function(id, options)
	{
		// Find all input from id container
		$$('#' + id + ' input').each(function(el) {
				var b = new Button3D(options, el);
				this.buttons.push(b);
				el.setStyle({display:'none', visibility:'hidden'});
		}.bind(this));
	}
});

Button3D = Class.create();
Button3D.prototype =
{
	initialize : function(options, el)
	{
		ref = null,
		type = null,
		name = '',
		callBackHandler = null,
		this.options = {callBack:null, imageOn : 'on.gif', imageOff : 'off.gif', imageOnHover : 'on_hover.gif', imageOffHover : 'off_hover.gif'};
		if (options)
		{
			if((options.imageOn && !options.imageOff) || (!options.imageOn && options.imageOff))
				jsFF.notice(sprintf("You must inform the two options '%s' and '%s', to get a functional button3d.", 'imageOn', 'imageOff'));
			else if(options.imageOn && options.imageOff)
			{
				this.options.imageOn = options.imageOn;
				this.options.imageOff = options.imageOff;
				
				if((options.imageOnHover && !options.imageOffHover) || (!options.imageOnHover && options.imageOffHover))
					jsFF.notice(sprintf("You must infom the two options '%s' and '%s', to get a functional button3d hover method.", 'imageOnHover', 'imageOffHover'));
				else if(options.imageOnHover && options.imageOffHover)
				{
					this.options.imageOnHover = options.imageOnHover;
					this.options.imageOffHover = options.imageOffHover;
				}
			}
			if (options.callBack)
				this.callBackHandler = options.callBack.bind(this);
		}
		if (el.type == 'radio' || el.type == 'checkbox')
		{
			this.ref = el;
			this.type= el.type;
			this.name = el.name;
			this.img = Builder.node('IMG', {src: ''});
			this.setImage(el.checked);
			el.insert({after: this.img});
			this.clickHandler = this._onClick.bind(this);
			this.img.observe('click', this.clickHandler);
			this.img.observe('mouseover', this._mouseOver.bind(this));
			this.img.observe('mouseout', this._mouseOut.bind(this));
		}
	},
	setImage : function (checked)
	{
		if (checked)
			if (this.options.imageOn.lastIndexOf('/') == -1) 
				var img = jsFF.getAccessPath() + '/lib/3dButtons/' + this.options.imageOn;
			else
				var img = this.options.imageOn;
		else
			if (this.options.imageOff.lastIndexOf('/') == -1) 
				var img = jsFF.getAccessPath() + '/lib/3dButtons/' + this.options.imageOff;
			else
				var img = this.options.imageOff;
		this.img.src = img;
		if(this.ref.disabled)
			this.img.setStyle({opacity:0.5});
	},
	_onClick: function (event)
	{
		if(this.ref.disabled)
			return;
		var path = jsFF.getAccessPath();
		this.ref.checked = ! this.ref.checked;
		this.setImage(this.ref.checked);
		if (this.type == 'radio')
		{
			jsFF._3DButtons.buttons.each(function(b) {
				if ( (b.ref != this.ref) && (b.name == this.name))
					b.setImage(! this.ref.checked);
			}.bind(this));
		}
		if (this.callBackHandler)
			this.callBackHandler();
	},
	_mouseOver: function(event)
	{
		if(this.ref.disabled)
			return ;
		if(this.ref.checked && this.options.imageOnHover!="")
		{
			if (this.options.imageOnHover.lastIndexOf('/') == -1) 
				var img = jsFF.getAccessPath() + '/lib/3dButtons/' +this.options.imageOnHover;
			else
				var img = this.options.imageOnHover;
		}
		else if(this.options.imageOffHover!="")
		{
			if (this.options.imageOffHover.lastIndexOf('/') == -1) 
				var img = jsFF.getAccessPath() + '/lib/3dButtons/' +this.options.imageOffHover;
			else
				var img = this.options.imageOffHover;
		}
		this.img.src = img ;
	},
	_mouseOut: function(event)
	{
		if(this.ref.disabled)
			return ;
		this.setImage(this.ref.checked);
	}
}
