jsFF.Paginator = Class.create({
	initialize : function(el, options)
	{
		_parent = null;
		_currentPage = 1; // current page, default 1
		_allItems = 0; // no. of repeating items in the container where paginator is applied
		_lastPage = 1; // last page, default 1
		_NbPaginator = 0;
		if (! options)
			options = {};
		this.options = {};
		this.options.startPage = options.startPage || 1; 						// start page
		this.options.itemsPerPage = options.itemsPerPage || 5; 					// no. of items you want to show on one page
		this.options.firstPageSymbol = options.firstPageSymbol || '<<';			// to indicate First Page
		this.options.previousPageSymbol = options.previousPageSymbol || '<'; 	// to indicate Previous Page
		this.options.nextPageSymbol = options.nextPageSymbol || '>'; 			// to indicate Next Page
		this.options.lastPageSymbol = options.lastPageSymbol || '>>'; 			// to indicate Last Page
		this.options.separator = options.separator || ' | ';						// To separate paginator's items
		this.options.paginatorPosition = options.paginatorPosition || 'bottom'; 		// where you want the paginator to be. Accepted values are 'top','bottom','both'
		this.options.paginatorStyle = options.paginatorStyle || 1;				// To define which style of paginator you need.
																		// 1 - for << | < | 1 | 2 | 3 | > | >>
																		// 2 - for << | < | 1/8 | > | >>
																		// 3 - for < | 1 | 2 | 3 | >
																		// 4 - for < | >
		this.options.enablePageOfOption = options.enablePageOfOption || false;	// it shows on which are you currently, i.e. Page 3 of 6 Page(s), if turned true
		this.options.enableGoToPage = options.enableGoToPage || false;			 // shows a drop down of all pages for go/jump to any page user want to go, if turned true. Useful incase there are large no. of pages
		this.options.textGoToPage = options.textGoToPage || 'Jump to';			// text for above option. You can change it to 'Jump to Page' or anything you like. The above option needs to turned on for this.
		this.options.enableSelectNoItems = options.enableSelectNoItems || false;	// if you want to change items per page on the fly.
		this.options.textSelectNoItems = options.textSelectNoItems || 'Items Per Page';
																		// text for above option. You can change it to 'Change No. of tag/page' or anything you like. The above option needs to turned on for this.
		this.options.paginatorValues = options.paginatorValues || Array(5,10,15,20,25,30);
																		// list of values for above option (enableSelectNoItems).
		this.options.anchorLink = options.anchorLink || 'javascript:void(0);';		// if you want to change href of the paginator anchor text (links for page) to '#' or to something else. As # is append on the address bar upon clicking I used javascript:void(); which is clean.
		this.options.showIfSinglePage = options.showIfSinglePage || true;			// set it to false if you don't want to show paginator incase there is only one page, true if show paginator even if there is just one page.
		this._NbPaginator = jsFF._Paginators.length;
		// initialisation
		this._parent=$(el);
		var paginator = Builder.node('div', {className : 'paginator'});
		switch(this.options.paginatorPosition)
		{
			case 'top':
				this._parent.insert({ before: paginator});
				break;
			case 'bottom':
				this._parent.insert({ after: paginator});
				break;
			case 'both': 
				this._parent.insert({ before: paginator});
				this._parent.insert({ after: paginator.clone()});
				break;
			default:
				this._parent.insert({ after: paginator});
		}
		if (this.options.itemsPerPage < 1)
			this.options.itemsPerPage = 5;
		this._allItems = this._parent.childElements().length; 		//FF children().length; 	// finding number of total items in content
		if(this._allItems % this.options.itemsPerPage == 0) 					// calculating last page of the paginator
			this._lastPage = parseInt(this._allItems / this.options.itemsPerPage);
		else
			this._lastPage = parseInt(this._allItems/ this.options.itemsPerPage)+1;
		if((this.options.startPage < 1)||(this.options.startPage > this._lastPage))	// start page for pagination
			this.options.startPage = 1;
		if(! this.options.showIfSinglePage)						// check if option is set to false
		{
			if(this._lastPage > 1)  // show pagination only if there is more than 1 page.
			this.appendContent(this.options.startPage, 1);
		}
		else
			this.appendContent(this.options.startPage, 1);	// call function to show start page for first time. Fading effect is not required initially.
	},
	removePagination: function() {
		$$('.paginator').each( function (el) {
			var n = el.next();
			var p = el.previous();
			if ((n && n.id == this._parent.id) || (p && p.id == this._parent.id))
				el.remove();
		}.bind(this));
//		this._parent.children().show(); 									// show all content of the div where pagination was applied.
	},
	appendContent : function(page, effect) 
	{
		if(page < 0)
			if(page == -1)
				page = this._currentPage - 1;
			else
				page = this._currentPage + 1;
		this._currentPage = page; // get current page or page selected.
		till = (this._currentPage-1)*this.options.itemsPerPage;
		if(1==0 && !effect)  // Page change without fading effect
		{
			this._parent.fadeOut("medium", function () { 					// fade out the current content 
				this._createPaginator();  								// create new paginator
				this._parent.children().hide();  							// hide all child element of content
				this._parent.children().slice(till, itemsPerPage+till).show();	// show only those items according to page selected. 
				this._parent.fadeIn("medium");							// use nice fade in effect to show the items of that selected page.
			});
		}
		else //with fading effect
		{
			this._createPaginator();   									// create new paginator
			this._parent.childElements().each( function (child) {			// hide all child element of content
				child.hide();
			});
			this._parent.childElements().slice(till, this.options.itemsPerPage+till).each( function (child) {	  		// show only those items according to page selected.
				child.show();
			});
		}
	},
	_createPaginator : function()
	{
		$$('.paginator').each( function (el) {
			var n = el.next();
			var p = el.previous();
			if ((n && n.id == this._parent.id) || (p && p.id == this._parent.id))
				el.childElements().each( function (child) {
					child.remove();
				});
		}.bind(this));
		var style1 = ''; // for << | < | 1 | 2 | 3 | > | >>
		var style2 = ''; // for << | < | 1/8 | > | >>
		var style3 = ''; // for < | 1 | 2 | 3 | >
		var style4 = ''; // for < | >
		var pageOfOption = ' Page '+this._currentPage+' of '+this._lastPage+' Page(s) ';  // for showing page info option
		var goToPage = ' '+ this.options.textGoToPage + ' <select onchange="appendContent(this.value);" >'; // for go to page option 
		var selectNoItems = ' '+ this.options.textSelectNoItems + ' <select onchange="itemsPerPage=Number(this.value);initPaginator();" >';  // for changing items per page option

		for(var i=0; i < this.options.paginatorValues.length; i++) // preparing drop down for selectNoItems option
		{
			if(this.options.itemsPerPage == this.options.paginatorValues[i])
				selectNoItems += '<option value="'+this.options.paginatorValues[i]+'" selected="selected">'+this.options.paginatorValues[i]+'</option>';
			else
				selectNoItems += '<option value="'+this.options.paginatorValues[i]+'">'+this.options.paginatorValues[i]+'</option>';
		}
		selectNoItems += '</select>';

		if(this._currentPage == 1) // for setting paginator style if current page is first page
		{
			style = '<a href="'+this.options.anchorLink+'" class="paginator-inactive" title="First Page">'+this.options.firstPageSymbol+'</a>' + this.options.separator;
			style1 = style2 = style;
			style = '<a href="'+this.options.anchorLink+'" class="paginator-inactive" title="Previous Page">'+this.options.previousPageSymbol+'</a>' + this.options.separator;
			style1 += style; 
			style2 += style;
			style3 += style;
			style4 += style;
		}	
		else // for setting paginator style for first page links
		{
			style = '<a href="'+this.options.anchorLink+'" class="paginator-active" onclick="appendContent(1);" title="First Page">'+this.options.firstPageSymbol+'</a>' + this.options.separator;
			style1 = style2 = style;
			style = '<a href="'+this.options.anchorLink+'" class="paginator-active" onclick="appendContent(-1);" title="Previous Page">'+this.options.previousPageSymbol+'</a>' + this.options.separator;
			style1 += style;
			style2 += style;
			style3 += style;
			style4 += style;
		}

		for(var i=1;i<=this._lastPage;i++) // prepareing links for pages 
			if(i == this._currentPage) // if page is current page then set anchor class to inactive and no onclick function.
				{
					style1 += '<a href="'+this.options.anchorLink+'" class="paginator-inactive" title="Page '+i+'">'+i+'</a>' + this.options.separator;
					style2 += '<a href="'+this.options.anchorLink+'" class="paginator-inactive" title="Page '+i+'">'+i+'/'+this._lastPage+'</a>' + this.options.separator;
					style3 += '<a href="'+this.options.anchorLink+'" class="paginator-inactive" title="Page '+i+'">'+i+'</a>' + this.options.separator;
					goToPage += '<option value="'+i+'" selected="selected">'+i+'</option>'; // preparing go to option drop down
				}
			else // if page is not current page then set anchor class to active and put onclick appendContent function.
				{
					style = '<a href="'+this.options.anchorLink+'" class="paginator-active" onclick="jsFF.getPaginator(' + this._NbPaginator + ').appendContent('+i+');" title="Page '+i+'">'+i+'</a>' + this.options.separator;
					style1 += style;
					style3 += style;
					goToPage += '<option value="'+i+'">'+i+'</option>';  // preparing go to option drop down
				}
		goToPage += '</select>';  // preparing go to option drop down

		if(this._currentPage == this._lastPage) // for setting paginator style if current page is last page
		{
			style = '<a href="'+this.options.anchorLink+'" class="paginator-inactive" title="Next Page">'+this.options.nextPageSymbol+'</a>';
			style1 += style;
			style2 += style;
			style3 += style;
			style4 += style;
			style = this.options.separator + '<a href="'+this.options.anchorLink+'" class="paginator-inactive" title="Last Page">'+this.options.lastPageSymbol+'</a>';
			style1 += style;
			style2 += style;
		}
		else // for setting paginator style for last page links
		{
			style = '<a href="'+this.options.anchorLink+'" class="paginator-active" onclick="jsFF.getPaginator(' + this._NbPaginator + ').appendContent(-2);" title="Next Page">'+this.options.nextPageSymbol+'</a>';
			style1 += style;
			style2 += style;
			style3 += style;
			style4 += style;
			style = this.options.separator + '<a href="'+this.options.anchorLink+'" class="paginator-active" onclick="jsFF.getPaginator(' + this._NbPaginator + ').appendContent('+this._lastPage+');" title="Last Page">'+this.options.lastPageSymbol+'</a>';
			style1 += style;
			style2 += style;
		}
		switch (this.options.paginatorStyle) // getting which style of pagination is mentioned.
		{
			case 1 : style = style1; break;
			case 2 : style = style2; break;
			case 3 : style = style3; break;
			case 4 : style = style4; break;
			default : style = style1;
		}
		// appending various other options if they are enabled or set to true.
		if(this.options.enablePageOfOption)
			style += '<span class="paginator-inactive" title="Page Information">' + this.options.pageOfOption + '</span>';
		if(this.options.enableGoToPage)
			style += '<span class="paginator-inactive" title="Select Page">' + this.options.goToPage + '</span>';
		if(this.options.enableSelectNoItems)
			style += '<span class="paginator-inactive" title="Select no. of items per page">' + this.options.selectNoItems + '</span>';
		var arr = $$('.paginator');
		$$('.paginator').each( function (style, el) {
			var n = el.next();
			var p = el.previous();
			if ((n && n.id == this._parent.id) || (p && p.id == this._parent.id))
				el.innerHTML = style;
		}.bind(this, style));
	}
});