/* Ultimate Fade-in slideshow (v2.1)
* Last updated: Sept 10th, 2009. This notice must stay intact for usage 
* Author: Dynamic Drive at http://www.dynamicdrive.com/
* Visit http://www.dynamicdrive.com/ for full source code
*/

jsFF.fadeSlideShow_descpanel={
	controls: [['x.png',7,7], ['restore.png',10,11], ['spinner.gif',50,50]],		//full URL and dimensions of close, restore, and loading images
	fontStyle: 'normal 11px Verdana',															//font style for text descriptions
	slidespeed: 200																						//speed of description panel animation (in millisec)
}

jsFF.FadeSlideShow = Class.create({
	initialize : function(el, imageArray, options)
	{
		this._parent = null;
		this._longestDesc = '';
		this._isMouseOver = false;
		this._imageArray = imageArray;
		this._fgLayer = 0;						//index of active and background layer (switches after each change of slide)
		this._bgLayer = 1;						//index of inactive and background layer (switches after each change of slide)
		this._layers = new Array();
		this._executor = null;
		this._slideShowHandler = null;
		this._currentStep=1;					//keep track of # of slides slideshow has gone through (applicable in displayMode='auto' only)
		this._curImage = 0;
		this._stopped = false;
		this._closeButton = '';
		this._totalSteps = 0;
		this._restoreButton = null;
		this._descPanel = null;
		this._descInner = null;
		this._toggleDiv = null;
		this._elPrev = null;
		this._elNext = null;
		this._elStatus = null;
		this._onInitHandler = null;
		this._onSlideHandler = null;
		this._onTerminateCycleHandler = null;

		if (! options)
			options = {};

		this.options = {};
		this.options.dimensions = options.dimensions || [ 800, 600];
		this.options.fadeDuration=options.fadeDuration? parseInt(options.fadeDuration) : 1000;
		if (this.options.fadeDuration >= 100)
			this.options.fadeDuration /= 1000;
		this._curImage=(options.persist)? this.getCookie("gallery-"+options.wrapperid) : options.curImage || 0;
		this.options.displayMode = options.displayMode || {type:'auto', pause:4000, cycles:0, wraparound:false};
		this._totalSteps = imageArray.length*(options.displayMode.cycles > 0 ? options.displayMode.cycles : Infinity);	//Total steps limit (applicable in displayMode='auto' only w/ cycles>0)
		if (this.options.displayMode.pause >= 1000)
			this.options.displayMode.pause /= 1000;
		this.options.persist = options.persist || false;
		this.options.descReveal = options.descReveal || 'onDemand';
		this.options.togglerid = options.togglerid || '';
		this.options.onInit=options.onInit || function(){};
		this.options.onSlide=options.onSlide || function(){};
		this.options.onTerminateCycle=options.onTerminateCycle || function(){};
		if (options.displayMode.randomize) //randomly shuffle order of images?
			imageArray.sort(function() {return 0.5 - Math.random()});

		this._parent = $(el);	// Initialisation ...
		if (! this._parent)
		{
			jsFF.error('Error during the creation of new component FadeSlideShow.');
			return;
		}
		// Recreation ?
		if (this._parent.style.display == 'none')
			this._parent.setStyle({display: 'block', visibility: 'visible'});
		// Handler des evenements
		this._onInitHandler = this.options.onInit.bind(this);
		this._onSlideHandler = this.options.onSlide.bind(this);
		this._onTerminateCycleHandler = this.options.onTerminateCycle.bind(this);
		
		this._parent.childElements().each( function (child) {
			child.remove();	// Nettoyage eventuel
		});
		this._parent.setStyle({
			position:'relative', 
			visibility:'visible', 
			background:'black', 
			overflow:'hidden', 
			width: this.options.dimensions[0], 
			height:this.options.dimensions[1]
		});

		// Cration des conteneurs pour les images
		var fullhtml=this.getFullHTML(imageArray) //get full HTML of entire slideshow
		var d1 = Builder.node('div', {className : 'gallerylayer'});
		d1.setStyle({position:'absolute', left:0, top:0, width:'100%', height:'100%', background:'black'});
		this._layers.push(d1);
		d1 = this._layers[this._fgLayer].clone()
		this._layers.push(d1);
		this._parent.insert({bottom: this._layers[this._bgLayer]});
		this._parent.insert({bottom: this._layers[this._fgLayer]});
		this._layers[this._bgLayer].setStyle({zIndex : 999});
		this._layers[this._fgLayer].setStyle({zIndex : 1000});

		var loadingimg= Builder.node('img', {
			src : jsFF.getAccessPath() + 'css/' + jsFF.fadeSlideShow_descpanel.controls[2][0],
			width: jsFF.fadeSlideShow_descpanel.controls[2][1],
			height: jsFF.fadeSlideShow_descpanel.controls[2][2]
		});
		loadingimg.setStyle({
			position: 'absolute',
			marginLeft: this.options.dimensions[0]/2 - jsFF.fadeSlideShow_descpanel.controls[2][1]/2 + 'px', 
			marginTop: this.options.dimensions[1]/2 - jsFF.fadeSlideShow_descpanel.controls[2][2]/2 + 'px',
			zIndex : 1002
		});
		this._parent.insert({bottom: loadingimg});

		// pre-loading images
		this._longestDesc="";	
		for (var i=0; i<imageArray.length; i++)
		{
			var img = Builder.node('img');
			this._layers[this._bgLayer].insert({bottom: img});
			img.src = imageArray[i][0];
			img.show();
			if (imageArray[i][3] && imageArray[i][3].length > this._longestDesc.length)
				this._longestDesc=imageArray[i][3];
		}
		this._layers[this._bgLayer].childElements().each(function(el){ el.remove(); });
		
		var closebutt=jsFF.getAccessPath() + 'css/' + jsFF.fadeSlideShow_descpanel.controls[0][0];		//add close button to "desc" panel if descReveal="always"
		this._closeButton=(this.options.descReveal=="always")? '<img class="close" src="'+closebutt+'" style="float:right;cursor:hand;cursor:pointer;width:'+jsFF.fadeSlideShow_descpanel.controls[0][1]+'px;height:'+jsFF.fadeSlideShow_descpanel.controls[0][2]+'px;margin-left:2px" title="Hide Description" />' : '';

		this._layers[this._bgLayer].innerHTML = fullhtml;
		this._layers[this._bgLayer].select('img').each( function (img) {
			img.hide();
		}.bind(this));

		this._layers[this._fgLayer].innerHTML = fullhtml;
		this._layers[this._fgLayer].select('img').each( function (img) {
			if (img.src.indexOf(this._imageArray[this._curImage][0]) != -1)
			{
				img.setStyle({
					marginLeft: (img.width>0 && img.width<this.options.dimensions[0]) ? this.options.dimensions[0]/2-img.width/2+'px' : 0,
					marginTop: (img.height>0 && img.height<this.options.dimensions[1]) ? this.options.dimensions[1]/2-img.height/2+'px' : 0
				});
				img.show();
			}
			else
				img.hide();
		}.bind(this));

		if (this._longestDesc != "")	//if at least one slide contains a description (feature is enabled)
		{
			this.addDescPanel();
			if (this.options.descReveal=="always")	//position desc panel so it's visible to begin with
			{
				this._descPanel.setStyle({top:this.options.dimensions[1]-this.options.panelheight + 'px'});
				this._descInner.observe('click', function(e) {			//assign click behavior to "close" icon
					if (e.target.className=="close")
						this.showHideDescpanel('hide');
				}.bind(this));
				this._restoreButton.observe('click', function(e){		//assign click behavior to "restore" icon
					this.showHideDescpanel('show');
					e.target.setStyle({visibility:'hidden'});
				}.bind(this));
			}
			else	//display desc panel on demand (mouseover)
			{
				this._parent.observe('mouseenter', function(){this.showHideDescpanel('show')}.bind(this));
				this._parent.observe('mouseleave', function(){this.showHideDescpanel('hide')}.bind(this));
			}
		}

		this._parent.observe('mouseenter', function(){this._isMouseOver=true;}.bind(this));
		this._parent.observe('mouseleave', function(){this._isMouseOver=false;}.bind(this));

		loadingimg.hide();
		this.paginateInit();
		this._executor = new PeriodicalExecuter( function (){ this.showSlide('next');}.bind(this), this.options.displayMode.pause);
		this._onInitHandler();
	},
	remove: function ()
	{
		if (this.options.persist)	//remember last shown image's index
			this.setCookie("gallery-"+this.options.wrapperid, this._curImage);
		this._parent.childElements().each(function(el){ el.remove(); });
		this._parent.fade({duration: 1.0, afterFinish: function() {
				if (this.options.togglerid)
					$(this.options.togglerid).fade({duration: 1.0});
			}.bind(this)
		});
		for (i=0; i < jsFF._fadeSlides.length; i++)
			if (jsFF._fadeSlides[i]._parent.id == this._parent.id)
				jsFF._fadeSlides[i]=null;
	},
	showSlide:function(keyword)
	{
		if (this.options.displayMode.type=="auto" && this._isMouseOver && this._currentStep<=this._totalSteps)
			return;
		var imgindex=(keyword=="next")? (this._curImage<this._imageArray.length-1? this._curImage+1 : 0)
			: (keyword=="prev")? (this._curImage>0? this._curImage-1 : this._imageArray.length-1)
			: Math.min(keyword, this._imageArray.length-1);
		this._layers[this._bgLayer].select('img').each( function (imgindex, img) {
			if (img.src.indexOf(this._imageArray[imgindex][0]) != -1)
			{
				img.setStyle({						//center align image
					marginLeft: (img.width>0 && img.width<this.options.dimensions[0]) ? this.options.dimensions[0]/2-img.width/2+'px' : 0,
					marginTop: (img.height>0 && img.height<this.options.dimensions[1]) ? this.options.dimensions[1]/2-img.height/2+'px' : 0
				});
				img.show();
			}
			else
				img.hide();
		}.bind(this, imgindex));

		this._layers[this._bgLayer].setStyle({zIndex:1000, opacity:0});
		new Effect.Opacity(this._layers[this._bgLayer], {
			from: 0.0, to: 1.0, duration: this.options.fadeDuration,  afterFinish: function() {
				this._currentStep+=1;
				this._onSlideHandler();
			}.bind(this)
		});
		this._layers[this._fgLayer].setStyle({zIndex:999});		//foreground layer becomes background

		if (this._currentStep >= this._totalSteps && this.options.displayMode.cycles != 0 && !this._stopped)
		{
			this._executor.stop();
			this._stopped = true;
			this._onTerminateCycleHandler();
		}

		this._fgLayer=this._bgLayer;
		this._bgLayer=(this._bgLayer==0) ? 1 : 0;
		this._curImage=imgindex;

		if (this._descPanel)
			this._descPanel.setStyle({visibility:(this._imageArray[imgindex][3])? 'visible' : 'hidden'});

		if (this._imageArray[this._curImage][3])
		{
			this._descInner.childElements().each( function (el) { el.remove();});
			this._descInner.innerHTML = this._closeButton + this._imageArray[imgindex][3];
		}

		if (this._toggleDiv)
			this.paginateControl();

		if (this._elStatus)
		{
			
			this._elStatus.innerHTML = 'image ' + parseInt(this._curImage +1) + " / " + this._imageArray.length;
			if (this._imageArray[this._curImage][2])
				this._elStatus.innerHTML +=  ' - ' + this._imageArray[this._curImage][2];
		}
	},
	showHideDescpanel:function(state, showcontrol)
	{
		if (state=="show")
		{
			var posY = this.options.dimensions[1] + (-1 * this._descPanel.getHeight());
			this._descPanel.setStyle({visibility: 'visible', display: 'block'});
		}
		else
			var posY = this.options.dimensions[1];
		new Effect.Move(this._descPanel, {
			x: 0,
			y: posY,
			mode: 'absolute',
			afterFinish: function(state) {
				if (this.options.descReveal=="always" && state=="hide")	//show restore button
					this._restoreButton.setStyle({visibility:'visible'});
				if (state == 'hide')
					this._descPanel.setStyle({visibility: 'hidden'});
			}.bind(this, state)
		});
	},
	paginateInit : function()
	{
		if (this.options.togglerid)		//if toggler div defined
		{
			this._toggleDiv=$(this.options.togglerid);
			if (! this._toggleDiv)
				return;

			// Re-creation ??
			if (this._toggleDiv.style.display == 'none')
				this._toggleDiv.setStyle({display: 'block', visibility: 'visible'});

			this._elPrev = this._toggleDiv.select('.prev')[0];
			if (this._elPrev)
			{
				this._elPrev.writeAttribute('action', 'prev');
				this._elPrev.observe('click', function(e) {
					this.navigate(e.target.readAttribute('action'));
				}.bind(this));
			}

			this._elNext = this._toggleDiv.select('.next')[0];
			if (this._elNext)
			{
				this._elPrev.writeAttribute('action', 'next');
				this._elNext.observe('click', function(e) {
					this.navigate(e.target.readAttribute('action'));
				}.bind(this));
			}
			this._elStatus=this._toggleDiv.select('.status')[0];
			if (this._elStatus)
			{
				
				this._elStatus.innerHTML = 'image ' + parseInt(this._curImage +1) + " / " + this._imageArray.length;
				if (this._imageArray[this._curImage][2])
					this._elStatus.innerHTML +=  ' - ' + this._imageArray[this._curImage][2];
			}
			this.paginateControl();
		}
	},
	paginateControl:function()
	{
		if (this._elPrev)
		{
			if (this._curImage == 0)
				active = false;
			else
				active = true;
			this._elPrev.setStyle({opacity:(active) ? 1 : 0.4, cursor:(active) ? 'pointer' : 'default'});
			this._elPrev.writeAttribute('action', (active) ? 'prev' : 'none');
		}
		active = true;
		if (this._elNext)
		{
			if (this._curImage >= this._imageArray.length-1)
				active = false;
			else
				active =  true;
			this._elNext.setStyle({opacity:(active) ? 1 : 0.4, cursor:(active) ? 'pointer' : 'default'});
			this._elNext.writeAttribute('action', (active) ? 'next' : 'none');
		}
	},
	navigate:function(keyword)
	{
		if (this._executor.timer != null)
			this._executor.stop();
		if (keyword == 'none')
			return;
		if (this.options.displayMode.type=="auto")		//in auto mode
		{
			this.options.displayMode.type="manual" //switch to "manual" mode when nav buttons are clicked on
			this.options.displayMode.wraparound=true //set wraparound option to true
		}
		if (!isNaN(parseInt(keyword)))		//go to specific slide?
			this.showSlide(parseInt(keyword))
		else if (/(prev)|(next)/i.test(keyword))	//go back or forth inside slide?
			this.showSlide(keyword.toLowerCase())
	},
	getSlideHTML:function(imgelement)
	{
		var layerHTML = (imgelement[1]) ? '<a href="'+imgelement[1]+'" target="'+imgelement[2]+'">\n' : '';
		layerHTML+='<img src="'+imgelement[0]+'" style="border-width:0;" />\n';
		layerHTML+=(imgelement[1])? '</a>\n' : '';
		return layerHTML;
	},
	getFullHTML:function(imageArray)
	{
		var preloadhtml=''
		for (var i=0; i<imageArray.length; i++)
			preloadhtml+=this.getSlideHTML(imageArray[i])
		return preloadhtml
	},
	addDescPanel:function()
	{
		this._descPanel= Builder.node('div',{className:'fadeslidedescdiv'});
		this._descPanel.setStyle({
			position:'absolute', 
			visibility: 'hidden', 
			width:'100%', 
			left:0, 
			top: this.options.dimensions[1] + 'px', 
			font: jsFF.fadeSlideShow_descpanel.fontStyle, 
			zIndex:'1001'
		});
		this._parent.insert({bottom: this._descPanel});
		
		var innerBg = Builder.node('div', {className: 'descpanelbg'});
		innerBg.setStyle({
			position:'absolute', 
			left:0, 
			top:0,
			width: this._descPanel.getWidth()-8 + 'px', 
			padding:'4px',
			background:'none repeat scroll 0% 0% black', 
			opacity:0.7
		});
		this._descPanel.insert({bottom: innerBg});
		
		var innerFg = Builder.node('div', {className: 'descpanelfg'});
		innerFg.setStyle({
			position:'absolute', 
			left:0, 
			top:0, 
			width: this._descPanel.getWidth()-8 + 'px', 
			padding:'4px',
			color:'white'
		});
		innerFg.innerHTML = this._closeButton + this._longestDesc;
		this._descPanel.insert({bottom: innerFg});
		this._descInner = this._descPanel.select('div.descpanelfg')[0];

		this._descPanel.setStyle({height: this._descInner.getHeight() + 'px'});
		
		this._descPanel.select('div').each( function (el) {
			el.setStyle({height:'100%'});
		});

		if (this.options.descReveal=="always")	//create restore button
		{
			this._restoreButton = Builder.node('img', {
				className: "restore", 
				title:"Restore Description", 
				src: jsFF.getAccessPath() + 'css/' + jsFF.fadeSlideShow_descpanel.controls[1][0],
				style: "position:absolute;visibility:hidden;right:0;bottom:0;z-index:1002;width:" + jsFF.fadeSlideShow_descpanel.controls[1][1]+'px;height:'+jsFF.fadeSlideShow_descpanel.controls[1][2]+'px;cursor:pointer;cursor:hand'
			});
			this._parent.insert({bottom: this._restoreButton});
			this._descPanel.setStyle({visibility: 'visible', top: this.options.dimensions[1]  - this._descPanel.getHeight() + 'px'});
		}
	},
	getCookie:function(Name)
	{
		var re=new RegExp(Name+"=[^;]+", "i"); //construct RE to search for target name/value pair
		if (document.cookie.match(re)) //if cookie found
			return document.cookie.match(re)[0].split("=")[1];	//return its value
		return null;
	},
	setCookie:function(name, value)
	{
		document.cookie = name+"=" + value + ";path=/";
	}
});