/***********************************************************************************************
* - SPaner - fluidspaner.js version 1.2, Fri Apr 10 13:32:57 -0200 2009
    Slide smoothly horizontal panes.
	 
 [ THIS IS A COPYRIGHTED WORKS - MIT STYLE LICENCE ]
 
 tocra.org
 Experimental work for future diffusion
 Copyright (c) 2003-2008 Sebastien Bremond | www.tocra.org
 
 web-medias.com
 Copyright (c) 2007-2008 Sebastien Bremond | www.web-medias.com
***********************************************************************************************/	
jsFF_Spaner = Class.create({
	collection:{},
	version: 1.2,
	initialize: function(element, options)
	{
		if ( !$(element) )return;
		element_ref_id = $(element).readAttribute('id');
		this.collection[element_ref_id] = {
			transition:'EaseFromTo', 
			ajaxloadmsg:"Loading content, please wait ...",
			ajaxloadclass:"spaner_ajaxloader",
			
			basesize:0, 
			list:[],
			ajaxed:[],
			previous:null,
			current:null,
			next:null,
			height:null,
			spaner:$(element_ref_id),
			box:null, 
			animating:false,
			options:options
		};
		if (typeof(options.showLocation) == 'undefined')
			this.collection[element_ref_id].options.showLocation = true;
		var loader = $$('#'+element_ref_id+' .spaner_ajaxloader')[0];
		loader.show();
		jsFF._Spaner = this;
		this.build(element_ref_id);
		loader.hide();
	},
	build: function(element_ref_id)
	{
		this.collection[element_ref_id].height = this.collection[element_ref_id].spaner.up().getHeight() +'px';
		
		var boxspaner = $$('#'+element_ref_id+' .boxspaner')[0];
		this.collection[element_ref_id].box = boxspaner;
		var spaners = $$('#'+element_ref_id+' .boxspaner .tabspaner');		
		this.collection[element_ref_id].list = [];
		spaners.each(function(item)
		{
			this.collection[element_ref_id].list.push(item.readAttribute('id'));
			this.collection[element_ref_id].ajaxed.push(item.readAttribute('id'));
			this.collection[element_ref_id].ajaxed[item.readAttribute('id')] = {node:null, ajax:false, url:null, loaded:false, reloaded:false};
			var contentarea = $$('#'+item.readAttribute('id')+' .spaner-content')[0];
			if ( $(contentarea).hasClassName('ajaxspaner') )
			{
				this.collection[element_ref_id].ajaxed[item.readAttribute('id')].ajax = true;
				this.collection[element_ref_id].ajaxed[item.readAttribute('id')].url = $(contentarea).readAttribute('title');
				if ( $(contentarea).hasClassName('ajaxreloaded') )
					this.collection[element_ref_id].ajaxed[item.readAttribute('id')].reloaded = true;
				$(contentarea).title = '';
				this.collection[element_ref_id].ajaxed[item.readAttribute('id')].node = $(contentarea);
			}
		}.bind(this));
		
		if (this.collection[element_ref_id].options.autowidth)
		{
			Event.observe(window, 'resize', function(event) {
				this.adjust(element_ref_id);
			}.bind(this));
		}
		this.adjust(element_ref_id);

		boxspaner.setStyle({width:(2*this.collection[element_ref_id].basesize)+'px'});

		var required_spaner_id = 0;
		if ( this.isUrlHasHash(window.location.href) )
		{
			required_spaner_id = this.getAnchorIndex( element_ref_id , this.getAnchorFromHash( this.getUrlHash(window.location.href) ) );
			if (required_spaner_id==null){required_spaner_id = 0;}
		}
		
		spaners.each(function(item,idx){
			if (idx!=required_spaner_id){item.hide();}
			else{
				this.collection[element_ref_id].current = item.readAttribute('id');
			}
		}.bind(this));

		$$('a[href*="#"]').each(function(anchor){
			if (anchor.hasClassName('controler'))
			{
				anchor.observe('click', function(event) {
					Event.stop(event);
					if ( Event.element(event).tagName.toLowerCase() == "a")
					{
						var pageAnchor = Event.element(event).href.split('#')[1];
						this.slide(element_ref_id, pageAnchor);
					}
				}.bind(this));
			}
		}.bind(this));

		this.adjust(element_ref_id);
		
		$(document).fire("fluidspaner:ready", { fluidspaner: element_ref_id });
		return $(element_ref_id);
	},
	isUrlHasHash:function(url)
	{
		return ( String(url).lastIndexOf('#') != -1)? true:false;
	},
	getUrlHash:function(url)
	{
		return String(url).substring(String(url).lastIndexOf('#'));
	},
	getAnchorFromHash:function(hash)
	{
		return String(hash).split('#')[1];
	},
	getAnchorIndex:function(element_ref_id, anchor)
	{
		found = null;
		this.collection[element_ref_id].list.each(function(o,i){
			if (o===anchor){found = i};
		});
		return found;
	},
	getList:function(element_ref_id)
	{
		return this.collection[element_ref_id].list;
	},
	setTransition:function(element_ref_id,transition)
	{
		this.collection[element_ref_id].transition = transition;
	},
	buildBehavior:function(element_ref_id)
	{
		$$('a[href*="#"]').each(function(anchor){
			if (anchor.hasClassName('controler'))
			{
				Event.stopObserving(anchor, 'click');
				anchor.stopObserving('click');

				anchor.observe('click', function(event) {
					Event.stop(event);
					if ( Event.element(event).tagName.toLowerCase() == "a")
					{
						var pageAnchor = Event.element(event).href.split('#')[1];
						this.slide(element_ref_id, pageAnchor);
					}
				}.bind(this));
			}
		}.bind(this));
	},
	slide:function(element_ref_id,to)
	{
		if (this.getAnchorIndex(element_ref_id, to) == null)
			return;

		from = this.collection[element_ref_id].current;
		if (from == to)
			return;

		if (this.collection[element_ref_id].animating)
			return;

		this.collection[element_ref_id].animating = true;

		$(document).fire("fluidspaner:beforeSlide", { fluidspaner: element_ref_id });

		if ( this.collection[element_ref_id].ajaxed[to].ajax )
		{
			load_content = (this.collection[element_ref_id].ajaxed[to].loaded)? false:true;
			if ( this.collection[element_ref_id].ajaxed[to].reloaded )
				oad_content = true;
			
			if (load_content)
			{
				$(this.collection[element_ref_id].ajaxed[to].node).update( '<div class="'+this.collection[element_ref_id].ajaxloadclass+'" title="'+this.collection[element_ref_id].ajaxloadmsg+'"></div>' );
				new Ajax.Request(this.collection[element_ref_id].ajaxed[to].url, {
				  method: 'get',
				  onSuccess: function(transport) {
					  $(this.collection[element_ref_id].ajaxed[to].node).update( transport.responseText );
					  this.collection[element_ref_id].ajaxed[to].loaded = true;
					  this.buildBehavior(element_ref_id);
				  }.bind(this)
				});
			}
		}

		var offset = 0;
		var bound_down;
		var bound_up;
		(this.collection[element_ref_id].list).each(function(o,i){
			if ( o == from || o == to ){ $(o).show(); }else{ $(o).hide(); }
			if ( o == from ){ bound_down = i; }
			if ( o == to ){ bound_up = i; }
		});

		offset = (bound_up>bound_down) ? '0px' : '-'+this.collection[element_ref_id].basesize+'px';
		newoffset = (bound_up>bound_down) ?  '-'+this.collection[element_ref_id].basesize : '0';
		this.collection[element_ref_id].box.setStyle( {marginLeft:offset} );

		new Effect.Morph(this.collection[element_ref_id].box.readAttribute('id'), {
			style:'margin-left:'+newoffset+'px',
			duration: 0.8,
			transition: Effect.Transitions[this.collection[element_ref_id].transition],
			afterFinish: function(){
				if (this.collection[element_ref_id].options.showLocation)
					window.location.href = '#'+to;
				this.collection[element_ref_id].animating = false;
				$(document).fire("fluidspaner:afterSlide", { fluidspaner: element_ref_id });
			}.bind(this)
		});

		this.collection[element_ref_id].previous = this.collection[element_ref_id].current;
		this.collection[element_ref_id].current = to;
	},
	adjust:function(element_ref_id)
	{
		this.collection[element_ref_id].basesize = this.collection[element_ref_id].spaner.up().getWidth();
		offset = (parseInt(this.collection[element_ref_id].box.getStyle('marginLeft').replace(/px/g,""))<0)? '-100%':'0px';		
		this.collection[element_ref_id].spaner.setStyle( {width:'100%'} );
		this.collection[element_ref_id].box.setStyle( {width:'200%' , marginLeft:offset} );
	}
});
