jsFF._iconDock =  Class.create();
Object.extend(jsFF._iconDock,
{
	docks: new Array(),
	addDock : function(id, options)
	{
		new IconDock(id, options);
	},
	showDocks: function()
	{
		if  (this.docks.length > 0)
		{
			this.docks.each(function(dock){	// Traiter chaque objet IconDock du tableau....
				dock.startDock();
			});
			return true;
		}
		else
			return false;
	}
});

IconDock = Class.create();
IconDock.prototype =
{
	_elements: null,
	_preloadImgs: new Array(),
	initialize : function(id, options)
	{
		this._elements = new Array();
		this.options = options  || this.defaultConf();
		this.lastOver = 0;
		this.divDock = null;
		this.dockPare = id;
		this.isMoving = false;
		this.maxWidth = 0;
		jsFF._iconDock.docks.push(this);
		$$('#' + id + ' a').each(function(i) {
			var path = window.location.pathname.substr(0, window.location.pathname.lastIndexOf("/")+1);
			var el = new DockElement();
			var imgInt=i.getElementsBySelector("img")[0];
			var aInt=i;
			var imgsrc=path + imgInt.attributes["src"].value; 
			var liopunt=imgsrc.lastIndexOf("."); 
			var liobarra=imgsrc.lastIndexOf("_"); 
			el.srcSmall= imgsrc; 
			el.srcBig= imgsrc.substr(0,liobarra)+'_'+this.options.iconMaxSide+imgsrc.substr(liopunt,imgsrc.length-1);
			this._preloadImgs.push(new Image());
			this._preloadImgs[this._preloadImgs.length-1].src=el.srcBig;
			el.descripcio=aInt.attributes["title"].value;
			el.href=aInt.attributes["href"].value;
			if (aInt.getAttribute("target") != null)
				el.target=aInt.attributes["target"].value;
			else
				el.target='_self';
			var aname=aInt.attributes["name"].value;
			var imgalt=imgInt.attributes["alt"].value;
			el.titol=(aname)? aname : (imgalt)? imgalt : el.descripcio.substr(6,16)+"..." ;
			el.nEl = this._elements.length;
			this._elements.push(el);
		}.bind(this));
		this.maxWidth = this.options.iconMaxSide * this._elements.length;
	},
	defaultConf : function()
	{
		return {iconMinSide : 35, iconMaxSide : 70, distAttDock : 100, coefAttDock : 2, veloOutDock : 1000, valign: 'middle' };
	},
	startDock : function()
	{
		this._elements.each( function (el) {
			el.costatActual = this.options.iconMinSide;
			el.costatFinal = this.options.iconMinSide;			
		}.bind(this));
		this.resetDock();
	},
	resetDock : function()
	{
		var strHTML,resta,ptop,pbottom,divWidth;
		$(this.dockPare).setAttribute("align","center");
		strHTML="";
		this.divWidth=0;
		this.divDock = null;
		n = jsFF._iconDock.docks.length;
		this._elements.each(function (el) {
			var id = new Date().getTime();
			el.imgDock = 'imgDock_' + id + el.nEl;
			el.aParent = 'aDock_' + id;
			resta=this.options.iconMaxSide - el.costatActual;
			switch (this.options.valign) 
			{
				case 'bottom': ptop=resta; pbottom=0; break;
				case 'middle': ptop=resta/2; pbottom=resta/2; break;
				case 'top': ptop=0; pbottom=resta; break;							
			}	
			
			strHTML+='<a id="' + el.aParent + '" style="margin: 0; border:0;" href="'+el.href+'" target="' + el.target + '" title="'+el.descripcio+'">';
			strHTML+='<img id="' + el.imgDock +'" alt="'+el.titol+'" style="padding: '+ptop+'px 0 '+pbottom+'px 0; margin:0; border:0;" width="';
			strHTML+=el.costatActual+'" height="'+el.costatActual+'" src="';
			strHTML+=((el.costatActual>this.options.iconMinSide)? el.srcBig  : el.srcSmall)+'" /></a>';
			this.divWidth+=el.costatActual;
		}.bind(this));
		strHTML="<div class=\"docking\" style=\"margin:0; padding:0; border:0; width: "+divWidth+"px; height:"+this.options.iconMaxSide+"px; \">"+strHTML+"</div>";
		$(this.dockPare).innerHTML = strHTML;
		this.divDock = $(this.dockPare).getElementsBySelector("div.docking")[0];
		// Met en place les gestionnaires d'vnements.
		this.divDock.observe('mouseenter', this._mouseEnter.bind(this));
		this.divDock.observe('mousemove', this._mouseMove.bind(this));
		this.divDock.observe('mouseleave',this._mouseLeave.bind(this));
	},
	_mouseMove : function (event)
	{
		this.inDock(event.clientX);
		if (this.isMoving)
			this.moveDock(event.clientX);
	},
	_mouseEnter: function(event)
	{
		this.lastOver=new Date().getTime();
		this.inDock(event.clientX);
		this.overDock(event.clientX);
	},
	_mouseLeave: function (event)
	{
		var pos = this.divDock.viewportOffset();
		var gauche = pos.left;
		var droite = gauche + this.divDock.getWidth();
		var haut = pos.top;
		var bas = haut + this.divDock.getHeight();
		if (event.clientX >= gauche && event.clientX <= droite && event.clientY >= haut && event.clientY <= bas)
			return;	// Ne pas traiter le passage sur une image comme sortie de divDock ...
		this._elements.each( function (el) {
			el.costatFinal = this.options.iconMinSide;
		}.bind(this));
		this.outDock();
		this.isMoving = false;
	},
	overDock : function(posX)
	{
		var recrida=false;
		for (i=0; i < this._elements.length; i++)
		{
			var el = this._elements [i];
			if(el.costatActual < el.costatFinal) 
				recrida=true;
		}
		if (recrida) 
		{
			this.inDock(posX); 
			this.moveDock(posX);
			var self = this;
			setTimeout(function(){self.overDock(posX);}, 80);
		}
		else
			this.isMoving=true;
	},
	actDock : function (nEl,costat)
	{
		var img=$(this._elements[nEl].imgDock);
		var resta,ptop,pbottom,ampladaFinal;
		costat=Math.round(costat);
		resta=this.options.iconMaxSide-costat;
		switch (this.options.valign) {
			case 'bottom': ptop=resta; pbottom=0; break;
			case 'middle': ptop=resta/2; pbottom=resta/2; break;
			case 'top': ptop=0; pbottom=resta; break;							
		}
		img.src=(costat>this.options.iconMinSide)? this._elements[nEl].srcBig  : this._elements[nEl].srcSmall;
		ampladaFinal = this.divDock.getWidth() + costat - this._elements[nEl].costatActual;
		if (ampladaFinal >= this.maxWidth)
			ampladaFinal = this.maxWidth;
		img.setStyle({padding : ptop+"px 0px "+pbottom+"px 0px"} );
		this.divDock.setStyle({width: ampladaFinal + 'px'} );
		img.setStyle({width:costat+'px', height:costat+'px'});
		this._elements[nEl].costatActual=costat;
	},
	outDock : function () 
	{
		var tamanyPas=(this.options.iconMaxSide - this.options.iconMinSide)*100/this.options.veloOutDock;
		var recrida=false;
		for (i=0; i < this._elements.length; i++)
		{
			var el = this._elements [i];
			if ( (el.costatActual-tamanyPas) > this.options.iconMinSide)
			{ 
				recrida=true;
				var costat=el.costatActual - tamanyPas;
			} 
			else
				var costat=this.options.iconMinSide;
			this.actDock(el.nEl,costat);
		}
		if (recrida)
		{
			var self = this;
			setTimeout(function(){self.outDock();}, 80);
		}
		else
			this.startDock();
	},
	inDock : function (posX) 
	{
		var diferencia = this.options.iconMaxSide-this.options.iconMinSide;
		var k = Math.pow(this.options.distAttDock,this.options.coefAttDock);
		for (i=0; i < this._elements.length; i++)
		{
			var el = this._elements [i];
			var distancia=Math.abs(posX - $(el.imgDock).viewportOffset().left - parseInt(el.costatActual/2));
			var calc=-(diferencia*Math.pow(distancia, this.options.coefAttDock))/k;
			var costat = (calc<-diferencia)? this.options.iconMaxSide-diferencia : this.options.iconMaxSide+calc;
			el.costatFinal=costat;
		}
	},
	moveDock : function () 
	{
		var difOver=new Date().getTime()-this.lastOver;
		if(difOver<60) 
			return;
		var factorOv=(difOver/this.options.veloOutDock<1)? difOver/this.options.veloOutDock : 1;
		for (i=0; i < this._elements.length; i++)
		{
			var el = this._elements [i];
			if (factorOv < 1)
				var costat=this.options.iconMinSide+(el.costatFinal-this.options.iconMinSide)*factorOv;
			else
				var costat=el.costatFinal;
			this.actDock(el.nEl, costat);
		}
	}
}

DockElement = Class.create();
DockElement.prototype = 
{
	initialize : function(parent)
	{
		this.aParent = '';
		this.nEl = 0;
		this.posX=0;
		this.divWidth=0;
		this.imgDock = '';
		this.srcSmall = '';
		this.srcBig = '';
		this.titol = '';
		this.descripcio = '';
		this.href = '#';
		this.costatActual=0;
		this.costatFinal=0;
		this.pas = 0;
	}
}
