Object.extend(Event, {
	wheel: function(event){
		var delta = 0;
		if (!event)
			event = window.event;
		if (event.wheelDelta) 
		{
			delta = event.wheelDelta/120;
			if (window.opera) delta = -delta;
		} 
		else if (event.detail)
		{
			delta = -event.detail/3;
		}
		return Math.round(delta); //Safari Round
	}
});

jsFF._wheelScroll = Class.create({
	initialize : function(el, options)
	{
		this.options = options ||  { accel: 5, delay: 200, animStep: 40, steps: 5, endAnim : true, endAnimOscillation: 20, endAnimDuration: 0.02 };
		// TODO : Vrifier les options...
		this._step = -1;
		this._debScrolling = 0;
		this._wheelCount = 0;
		this._endPosition = 0;
		this._isWorking = false;
		this._el = $(el);
		this._handlerOnWheelScroll = null;
		if (this._el)
		{
			this._handlerOnWheelScroll = this._onWheelScroll.bind(this);
			var eventType = Prototype.Browser.Gecko ? "DOMMouseScroll" : "mousewheel";
			Event.observe(this._el, eventType, this._handlerOnWheelScroll);
			jsFF.message('wheelScroll('+ el + ') initialise...');
		}
		else
			jsFF.error(sprint(jsFF._e("jsFF.wheelScroll couldn't initialize : %s doesn't exist in DOM."), el));
	},
	_onWheelScroll: function (e)
	{
		var actualTime = new Date().getTime();
		Event.stop(e);
		if (this._debScrolling < 1)					//  Enregistre l'evenement et arme le decompte
		{
			this._debScrolling = actualTime;
			this._wheelCount = 1;
			jsFF.message('Lancement du timeout a  ' + actualTime);
			this._step = this.options.accel;
			var self = this;
			if (! this._isWorking)
				window.setTimeout(function () {self._startScrolling(Event.wheel(e));}, this.options.delay);
			else
				window.setTimeout(function () {self._onWheelScroll(e);}, 50);
			return;
		}
		if ((actualTime - this._debScrolling) < this.options.delay)		// Enregistrer les crans de la roue avant le delai
		{
			this._wheelCount += 2;
			return;
		}
		this._debScrolling = 0;
		this._wheelCount = 0;
		jsFF.message('droite => delta = ' + Event.wheel(e) + ' - horodatage = ' + actualTime);
	},
	_startScrolling: function (delta)
	{
		this._isWorking = true;
		if (this._step < 0)
		{
			this._wheelCount = 0;
			this._endPosition = this._el.scrollTop;
			if (this.options.endAnim)
			{
				var self = this;
				window.setTimeout(function () {self._animateEndScroll(delta, self.options.endAnimOscillation, self.options.endAnimDuration);}, 100);
			}
			else
				this._isWorking = false;
			return;
		}
		var actualTime= new Date().getTime();
		jsFF.message('Dans _startScrolling(delta = ' + delta + ') -> horodatage = ' + actualTime+ ' - this._wheelCount = ' + this._wheelCount) ;
		this._el.scrollTop -= delta * 16 * this._wheelCount;
		this._step--;
		(this._wheelCount > 0) ? this._wheelCount-- : 1;
		var self = this;
		window.setTimeout(function () {self._startScrolling(delta);}, this.options.animStep);
	},
	_animateEndScroll: function (delta, oscillation, duration)		// Oscillation finale : deplacement
	{
		if (oscillation < 2)
		{
			this._isWorking = false;
			jsFF.notice("Dans _animateEndScroll : oscillation = " + oscillation + " => Fin de l'animation !!!");
			return;
		}
		jsFF.message('Dans _animateEndScroll(delta = ' + delta + ', oscillation=' + oscillation + ' duration=' + duration + ')') ;
		var fin = this._endPosition + (delta * oscillation);
		new Effect.Tween(this._el, this._endPosition, fin , { 
			duration: 0.2, 
			afterFinish: function(delta, oscillation){ 
				this._animateEndScrollFinish(delta, oscillation, duration);
			}.bind(this, delta, oscillation)}, 
			function(p){
				this._el.scrollTop = p.round();
			}.bind(this));
	},
	_animateEndScrollFinish: function (delta, oscillation, duration)		// Oscillation finale : retour position.
	{
		jsFF.message('Dans _animateEndScrollFinish(delta = ' + delta + ', oscillation=' + oscillation + ' duration=' + duration + ')') ;
		var deb = this._endPosition - (delta * oscillation);
		new Effect.Tween(this._el, this._endPosition, deb , { 
			duration: 0.2, 
			afterFinish: function(delta, oscillation){ 
				this._animateEndScroll(delta, oscillation / 4, duration * 1.5);
			}.bind(this, delta, oscillation)}, 
			function(p){
				this._el.scrollTop = p.round();
			}.bind(this));
	}
});
